import 'isomorphic-fetch';
export interface GunNode {
    _: {
        '#': string;
        '>': {
            [key: string]: number;
        };
        [key: string]: any;
    };
    [key: string]: any;
}
export interface GunPutData {
    [soul: string]: GunNode;
}
export interface GunPut {
    put: GunPutData;
    from?: any;
}
declare const DEFAULT_CONFIG: {
    root: string;
};
export declare class GunHttpClient {
    Gun: any;
    env: any;
    dbi: any;
    config: typeof DEFAULT_CONFIG;
    constructor(Gun: any, httpConfig?: {
        root: string;
    });
    getRaw(soul: string): Promise<string>;
    get(soul: string): Promise<any>;
    read(soul: string): Promise<any>;
    writeNode(soul: string, nodeData: GunNode): Promise<void>;
    write(put: GunPutData): Promise<void>;
    close(): void;
}
export declare function createClient(Gun: any, options: any): GunHttpClient;
export {};
